%define VERSION 10.01
%define RELEASE 1

%define _ppddir /usr
%define _libdir /usr/lib
%define _com_libdir /opt/canon/lib
%define _sysconfdir /etc

%ifarch x86_64
%define	_machine_type "MACHINETYPE=x86_64"
%define	_cflags "CFLAGS=-m64 -march=x86-64"
%define	_arc _x86_64
%else
%ifarch aarch64
%define	_machine_type "MACHINETYPE=aarch64"
%define _cflags ""
%define	_arc _aarch64
%else
%ifarch mips64el
%define	_machine_type "MACHINETYPE=mips64el"
%define _cflags ""
%define	_arc _mips64
%else
%define	_machine_type "MACHINETYPE=i686"
%define	_cflags "CFLAGS=-m32 -march=i686"
%define	_arc _i686
%endif
%endif
%endif

Summary: IJ Printer Driver Ver.%{VERSION} for Linux
Name: cnijlfpfilter
Version: %{VERSION}
Release: %{RELEASE}
License: See the LICENSE*.txt file.
Vendor: CANON INC.
Group: Applications/Publishing
Source0: cnijlfpfilter-source-%{version}-%{release}.tar.gz
BuildRequires: cups-devel
Requires:  cups

%description
IJ Printer Driver for Linux. 
This IJ Printer Driver provides printing functions for Canon Inkjet
printers operating under the CUPS (Common UNIX Printing System) environment.

%prep
%setup -q -n cnijlfpfilter-source-%{version}-%{release}

%build
cd filter/canonijlfp
    ./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --enable-progpath=%{_bindir}
    make
cd -

cd filter/cmdtocanonijlfp
    ./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --enable-progpath=%{_bindir}
    make
cd -

cd filter/rastertocanonijlfp
    ./autogen.sh %{_machine_type} %{_cflags} --prefix=%{_prefix} --enable-progpath=%{_bindir}
    make
cd -


%install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_com_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/cups/filter
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/share/cups/model/Canon
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/share/cmdtocanonijlfp
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/ld.so.conf.d

cd filter/canonijlfp
    make install DESTDIR=${RPM_BUILD_ROOT}
cd -

cd filter/cmdtocanonijlfp
    make install DESTDIR=${RPM_BUILD_ROOT}
cd -

cd filter/rastertocanonijlfp
    make install DESTDIR=${RPM_BUILD_ROOT}
cd -

install -c -m 644 filter/cmdtocanonijlfp/utilfiles/*.utl ${RPM_BUILD_ROOT}%{_prefix}/share/cmdtocanonijlfp
install -c -m 644 ppd/*.ppd ${RPM_BUILD_ROOT}%{_prefix}/share/cups/model/Canon
find com/lib/libs_bin%{_arc} -name "libcn*.so*" -type f | xargs -i install -c -s -m 755 {} ${RPM_BUILD_ROOT}%{_com_libdir}
find com/lib/libs_bin%{_arc} -name "libcn*.so*" -type l | xargs -i cp -a {} ${RPM_BUILD_ROOT}%{_com_libdir}

echo %{_com_libdir} > ${RPM_BUILD_ROOT}%{_sysconfdir}/ld.so.conf.d/cnijlfpfilter.conf

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
if [ -x /sbin/ldconfig ]; then
	/sbin/ldconfig
fi

%postun
if [ -x /sbin/ldconfig ]; then
	/sbin/ldconfig
fi

%files
%{_bindir}/canonijlfp
%{_libdir}/cups/filter
%{_com_libdir}/libcn*.so*
%{_ppddir}/share/cmdtocanonijlfp
%{_prefix}/share/cups/model/Canon
%{_sysconfdir}/ld.so.conf.d/*.conf

%doc doc/LICENSE-cnijlfpfilter-*.txt

%doc lproptions/lproptions-*.txt

%changeLog
